/******************************************************************************
 ** $Id: AuswahlImHieb.java 739 2015-05-23 16:13:32Z wmh $
 ** Diese Datei ist Bestandteil der Java-Quelltexte des Würfelspiels JaFuffy.
 ** Lauffähig ab Java 6.
 ******************************************************************************
 ** Copyright (C) Wolfgang Hauck <wolfgang.hauck@3kelvin.de>
 ******************************************************************************
 ** This program is free software; you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation; either version 2 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ******************************************************************************
 ** Die aktuellste Version von JaFuffy findet sich im Internet unter
 ** <http://jafuffy.3kelvin.de>.
 **
 ** Kommentare, Fehler oder Erweiterungswünsche bitte per E-Mail senden an
 ** <jafuffy@3kelvin.de>.
 ******************************************************************************/
package jafuffy.bedienung;

import jafuffy.Eigenschaften;
import jafuffy.logik.AuswertungImHieb;
import jafuffy.logik.Turnier;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

/**
 * Auswahl der Zelle, in die das Würfelresultat gesetzt wird (Im-Hieb-Variante). Gibt
 * Im-Hieb-Meldung aus.
 */
@SuppressWarnings("serial")
public class AuswahlImHieb extends AuswahlKlassisch {

    // Timer in ms
    private static final int DELAY = 800;
    // verzögertes Setzen zum Absetzen einer Nachricht
    private final Timer timer = new Timer(DELAY, new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
            ((AuswertungImHieb) auswertung).imHiebNachrichtDeaktiv();
            turnier.setze(eintrag);
        }
    }) {
        @Override
        public boolean isRepeats() {
            return false;
        }
    };

    /**
     * Konstruktor.
     *
     * @param turnier
     */
    public AuswahlImHieb(Turnier turnier) {
        super(turnier);
    }

    /* Geklickt! */
    @Override
    void geklickt() {
        if (++clicks == 2 || Eigenschaften.GLOBAL.aktiv("Einfachklick")) {
            fireEditingStopped();
            if (((AuswertungImHieb) auswertung).imHieb(eintrag)) {
                ((AuswertungImHieb) auswertung).imHiebNachrichtAktiv(eintrag);
                HURRA.play();
                turnier.pausiere();
                timer.start();
            } else {
                turnier.setze(eintrag);
            }
        }
    }

}
